Index: branches/gui/src/lib/event/event_handler.cc
===================================================================
--- branches/gui/src/lib/event/event_handler.cc	(revision 8420)
+++ branches/gui/src/lib/event/event_handler.cc	(revision 8421)
@@ -355,5 +355,5 @@
   else
   {
-    SDL_WM_GrabInput(SDL_GRAB_ON);
+//    SDL_WM_GrabInput(SDL_GRAB_ON);
     SDL_ShowCursor(SDL_DISABLE);
   }
Index: branches/gui/src/lib/gui/gl/glgui_inputline.cc
===================================================================
--- branches/gui/src/lib/gui/gl/glgui_inputline.cc	(revision 8420)
+++ branches/gui/src/lib/gui/gl/glgui_inputline.cc	(revision 8421)
@@ -154,5 +154,4 @@
       }
     }
-
     return false;
   }
Index: branches/gui/src/lib/gui/gl/glgui_slider.cc
===================================================================
--- branches/gui/src/lib/gui/gl/glgui_slider.cc	(revision 8420)
+++ branches/gui/src/lib/gui/gl/glgui_slider.cc	(revision 8421)
@@ -74,4 +74,6 @@
     else
       this->_value = value;
+    this->_handle.setCenter(this->sliderPosition(), this->borderTop() + (this->getSizeY2D() - this->borderTop() - borderBottom()) / 2.0);
+
     emit(valueChanged(this->_value));
   }
@@ -161,6 +163,14 @@
   {
     GLGuiWidget::resize();
-/*    this->frontRect().setTopLeft(this->borderLeft(), this->getSizeY2D()/2.0 - 2.0);
-    this->frontRect().setSize(this->getSizeX2D() - borderLeft() - borderRight(), 4.0);*/
+//    this->frontRect().setTopLeft(this->borderLeft(), this->getSizeY2D()/2.0 - 2.0);
+//    this->frontRect().setSize(this->getSizeX2D() - borderLeft() - borderRight(), 4.0);
+    this->_slider.setTopLeft(this->borderLeft(), this->getSizeY2D() / 2.0 -2.0);
+    this->_slider.setSize(this->getSizeX2D() - borderLeft() - borderRight(), 4.0);
+    this->_handle.setSize(this->_sliderWidth, this->getSizeY2D() - borderTop() - borderBottom());
+  }
+
+  void GLGuiSlider::updateFrontColor()
+  {
+
   }
 
@@ -228,8 +238,8 @@
     GLGuiWidget::draw();
 
-    //this->frontMaterial().select();
-//     this->drawRect(this->frontRect());
-
-    this->drawRect(Rect2D(this->sliderPosition()-_sliderWidth/2.0, 0*this->borderTop(), _sliderWidth, this->getSizeY2D() - (borderTop() + borderBottom()) ));
+    glColor4fv(&this->frontColor()[0]);
+    this->drawRect(this->_slider);
+    this->drawRect(this->_handle);
+    //this->drawRect(Rect2D(this->sliderPosition()-_sliderWidth/2.0, 0*this->borderTop(), _sliderWidth, this->getSizeY2D() - (borderTop() + borderBottom()) ));
 
     this->endDraw();
Index: branches/gui/src/lib/gui/gl/glgui_slider.h
===================================================================
--- branches/gui/src/lib/gui/gl/glgui_slider.h	(revision 8420)
+++ branches/gui/src/lib/gui/gl/glgui_slider.h	(revision 8421)
@@ -56,4 +56,5 @@
   protected:
     virtual void resize();
+    virtual void updateFrontColor();
 
     virtual void clicking(const Vector2D& pos);
@@ -68,4 +69,7 @@
   private:
     Orientation      orientation;
+
+    Rect2D           _slider;
+    Rect2D           _handle;
 
     float            _maxValue;
Index: branches/gui/src/lib/math/rect2D.cc
===================================================================
--- branches/gui/src/lib/math/rect2D.cc	(revision 8420)
+++ branches/gui/src/lib/math/rect2D.cc	(revision 8421)
@@ -232,4 +232,35 @@
 
 /**
+ * @brief sets the new Center
+ * @param x the center's X to move the Rectangle to.
+ * @param y the center's Y to move the Rectangle to.
+ * moves the Rectangle from its current center to the new Center
+ */
+void Rect2D::setCenter(float x, float y)
+{
+  this->setCenter(Vector2D(x, y));
+}
+
+/**
+ * @brief sets the new Center
+ * @param center the center to move the Rectangle to.
+ * moves the Rectangle from its current center to the new Center
+ */
+void Rect2D::setCenterX(float x)
+{
+#warning implement this
+}
+
+/**
+ * @brief sets the new Center
+ * @param center the center to move the Rectangle to.
+ * moves the Rectangle from its current center to the new Center
+ */
+void Rect2D::setCenterY(float y)
+{
+#warning implement this
+}
+
+/**
  * @brief scales the Rectangle from topLeft out.
  * @param x: the scale factor in x direction
Index: branches/gui/src/lib/math/rect2D.h
===================================================================
--- branches/gui/src/lib/math/rect2D.h	(revision 8420)
+++ branches/gui/src/lib/math/rect2D.h	(revision 8421)
@@ -96,4 +96,8 @@
   void setSize(const Vector2D& size);
   void setCenter(const Vector2D& center);
+  void setCenter(float x, float y);
+  void setCenterX(float x);
+  void setCenterY(float y);
+
 
   void scaleX(float x);