Index: code/branches/bigships/src/modules/overlays/hud/HUDSpeedBar.cc
===================================================================
--- code/branches/bigships/src/modules/overlays/hud/HUDSpeedBar.cc	(revision 8136)
+++ code/branches/bigships/src/modules/overlays/hud/HUDSpeedBar.cc	(revision 8426)
@@ -54,7 +54,7 @@
         SUPER(HUDSpeedBar, tick, dt);
 
-        if (this->owner_ && this->owner_->getEngine())
+        if (this->owner_)
         {
-            float value = this->owner_->getVelocity().length() / (this->owner_->getEngine()->getMaxSpeedFront() * this->owner_->getEngine()->getSpeedFactor() * this->owner_->getEngine()->getBoostFactor());
+            float value = this->owner_->getVelocity().length() / (this->owner_->getMaxSpeedFront() * this->owner_->getSpeedFactor() * this->owner_->getBoostFactor());
             this->setValue(value);
         }
Index: code/branches/bigships/src/orxonox/controllers/HumanController.cc
===================================================================
--- code/branches/bigships/src/orxonox/controllers/HumanController.cc	(revision 8136)
+++ code/branches/bigships/src/orxonox/controllers/HumanController.cc	(revision 8426)
@@ -42,4 +42,5 @@
     extern const std::string __CC_fire_name = "fire";
     extern const std::string __CC_suicide_name = "suicide";
+    const std::string __CC_boost_name = "boost";
 
     SetConsoleCommand("HumanController", "moveFrontBack",          &HumanController::moveFrontBack ).addShortcut().setAsInputCommand();
@@ -51,5 +52,5 @@
     SetConsoleCommand("HumanController", __CC_fire_name,           &HumanController::fire          ).addShortcut().keybindMode(KeybindMode::OnHold);
     SetConsoleCommand("HumanController", "reload",                 &HumanController::reload        ).addShortcut();
-    SetConsoleCommand("HumanController", "boost",                  &HumanController::boost         ).addShortcut().keybindMode(KeybindMode::OnHold);
+    SetConsoleCommand("HumanController", __CC_boost_name,          &HumanController::toggleBoost   ).addShortcut().keybindMode(KeybindMode::OnPress);
     SetConsoleCommand("HumanController", "greet",                  &HumanController::greet         ).addShortcut();
     SetConsoleCommand("HumanController", "switchCamera",           &HumanController::switchCamera  ).addShortcut();
@@ -72,4 +73,5 @@
 
         controlPaused_ = false;
+        this->boosting_ = false;
 
         HumanController::localController_s = this;
@@ -163,8 +165,30 @@
     }
 
-    void HumanController::boost()
-    {
-        if (HumanController::localController_s && HumanController::localController_s->controllableEntity_)
-            HumanController::localController_s->controllableEntity_->boost();
+    /**
+    @brief
+        Static method,toggles boosting.
+    */
+    /*static*/ void HumanController::toggleBoost()
+    {
+        if (HumanController::localController_s && HumanController::localController_s->controllableEntity_)
+            HumanController::localController_s->toggleBoosting();
+    }
+    
+    /**
+    @brief
+        Toggles the boosting mode.
+        Changes the keybind mode of the boost console command and tells the ControllableEntity to boost (or not boost anymore).
+    */
+    void HumanController::toggleBoosting(void)
+    {
+        this->boosting_ = !this->boosting_;
+        
+        // The keybind mode of the boosting console command is onRelease if in boosting mode and onPress of not in boosting mode.
+        if(this->boosting_)
+            ModifyConsoleCommand(__CC_boost_name).keybindMode(KeybindMode::OnRelease);
+        else
+            ModifyConsoleCommand(__CC_boost_name).keybindMode(KeybindMode::OnPress);
+
+        this->controllableEntity_->boost(this->boosting_);
     }
 
Index: code/branches/bigships/src/orxonox/controllers/HumanController.h
===================================================================
--- code/branches/bigships/src/orxonox/controllers/HumanController.h	(revision 8136)
+++ code/branches/bigships/src/orxonox/controllers/HumanController.h	(revision 8426)
@@ -64,5 +64,13 @@
             static void reload();
 
-            static void boost();
+            static void toggleBoost(); // Static method,toggles boosting.
+            /**
+            @brief Check whether the HumanController is in boosting mode.
+            @return Returns true if it is, false if not.
+            */
+            inline bool isBoosting(void)
+                { return this->boosting_; }
+            void toggleBoosting(void); // Toggles the boosting mode.
+            
             static void greet();
             static void switchCamera();
@@ -92,4 +100,8 @@
             static HumanController* localController_s;
             bool controlPaused_;
+        
+        private:
+            bool boosting_; // Whether the HumanController is in boosting mode or not.
+
     }; // tolua_export
 } // tolua_export
Index: code/branches/bigships/src/orxonox/gametypes/Dynamicmatch.cc
===================================================================
--- code/branches/bigships/src/orxonox/gametypes/Dynamicmatch.cc	(revision 8136)
+++ code/branches/bigships/src/orxonox/gametypes/Dynamicmatch.cc	(revision 8426)
@@ -151,12 +151,5 @@
                 //Give new pig boost
                 SpaceShip* spaceship = dynamic_cast<SpaceShip*>(victim);
-                if (spaceship && spaceship->getEngine())
-                {
-                    spaceship->getEngine()->setSpeedFactor(5);
-                    WeakPtr<Engine>* ptr = new WeakPtr<Engine>(spaceship->getEngine());
-                    ExecutorPtr executor = createExecutor(createFunctor(&Dynamicmatch::resetSpeedFactor, this));
-                    executor->setDefaultValue(0, ptr);
-                    new Timer(10, false, executor, true);
-                }
+				grantPigBoost(spaceship);
             }
 
@@ -252,13 +245,5 @@
                 //Give new pig boost
                 SpaceShip* spaceship = dynamic_cast<SpaceShip*>(victim);
-                if (spaceship && spaceship->getEngine())
-                {
-                    spaceship->getEngine()->setSpeedFactor(5);
-                    WeakPtr<Engine>* ptr = new WeakPtr<Engine>(spaceship->getEngine());
-                    ExecutorPtr executor = createExecutor(createFunctor(&Dynamicmatch::resetSpeedFactor, this));
-                    executor->setDefaultValue(0, ptr);
-                    new Timer(10, false, executor, true);
-                }
-
+                grantPigBoost(spaceship);
             }
             // killer vs piggy
@@ -321,4 +306,17 @@
     }
 
+	void Dynamicmatch::grantPigBoost(orxonox::SpaceShip* spaceship)
+	{
+		// Give pig boost
+        if (spaceship)
+        {
+            spaceship->setSpeedFactor(5);
+            WeakPtr<SpaceShip>* ptr = new WeakPtr<SpaceShip>(spaceship);
+            ExecutorPtr executor = createExecutor(createFunctor(&Dynamicmatch::resetSpeedFactor, this));
+            executor->setDefaultValue(0, ptr);
+            new Timer(10, false, executor, true);
+        }
+	}
+
     void Dynamicmatch::playerStartsControllingPawn(PlayerInfo* player, Pawn* pawn) //set party + colouring
     {
@@ -597,5 +595,5 @@
     }
 
-    void Dynamicmatch::resetSpeedFactor(WeakPtr<Engine>* ptr)// helper function
+    void Dynamicmatch::resetSpeedFactor(WeakPtr<SpaceShip>* ptr)// helper function
     {
         if (*ptr)
Index: code/branches/bigships/src/orxonox/gametypes/Dynamicmatch.h
===================================================================
--- code/branches/bigships/src/orxonox/gametypes/Dynamicmatch.h	(revision 8136)
+++ code/branches/bigships/src/orxonox/gametypes/Dynamicmatch.h	(revision 8426)
@@ -73,5 +73,6 @@
             virtual void furtherInstructions();*/
             virtual void rewardPig();
-            void resetSpeedFactor(WeakPtr<Engine>* ptr);
+			void grantPigBoost(SpaceShip* spaceship); // Added this, since it's used twice on different occasions.
+            void resetSpeedFactor(WeakPtr<SpaceShip>* ptr);
             void tick (float dt);// used to end the game
             SpawnPoint* getBestSpawnPoint(PlayerInfo* player) const;
Index: code/branches/bigships/src/orxonox/items/Engine.cc
===================================================================
--- code/branches/bigships/src/orxonox/items/Engine.cc	(revision 8136)
+++ code/branches/bigships/src/orxonox/items/Engine.cc	(revision 8426)
@@ -35,5 +35,5 @@
 #include "Scene.h"
 #include "worldentities/pawns/SpaceShip.h"
-#include "tools/Shader.h"
+#include "core/Template.h"
 
 namespace orxonox
@@ -47,4 +47,5 @@
         this->ship_ = 0;
         this->shipID_ = OBJECTID_UNKNOWN;
+		this->relativePosition_ = Vector3(0,0,0);
 
         this->boostFactor_ = 1.5;
@@ -62,6 +63,4 @@
         this->accelerationUpDown_ = 0.0;
 
-        this->boostBlur_ = 0;
-
         this->speedAdd_ = 0.0;
         this->speedMultiply_ = 1.0;
@@ -75,8 +74,8 @@
         if (this->isInitialized() && this->ship_)
         {
-            this->ship_->setEngine(0);
-
-            if (this->boostBlur_)
-                this->boostBlur_->destroy();
+            //this->ship_->setEngine(0);
+
+            //if (this->boostBlur_)
+            //    this->boostBlur_->destroy();
         }
     }
@@ -98,13 +97,11 @@
         XMLPortParam(Engine, "accelerationleftright", setAccelerationLeftRight, setAccelerationLeftRight, xmlelement, mode);
         XMLPortParam(Engine, "accelerationupdown",    setAccelerationUpDown,    setAccelerationUpDown,    xmlelement, mode);
+
+		XMLPortParam(Engine, "position", setRelativePosition, getRelativePosition, xmlelement, mode);
+		XMLPortParam(Engine, "template", setEngineTemplate, getEngineTemplate, xmlelement, mode);
     }
 
     void Engine::setConfigValues()
     {
-        SetConfigValueExternal(bEnableMotionBlur_, "GraphicsSettings", "enableMotionBlur", true)
-            .description("Enable or disable the motion blur effect when moving very fast")
-            .callback(this, &Engine::changedEnableMotionBlur);
-        SetConfigValueExternal(blurStrength_, "GraphicsSettings", "blurStrength", 3.0f)
-            .description("Defines the strength of the motion blur effect");
     }
 
@@ -202,23 +199,15 @@
         }
 
-        this->ship_->setAcceleration(this->ship_->getOrientation() * (acceleration*this->getSpeedMultiply()+Vector3(0,0,-this->getSpeedAdd())));
-
-        if (!this->ship_->getPermanentBoost())
-            this->ship_->setBoost(false);
-        this->ship_->setSteeringDirection(Vector3::ZERO);
-
-        if (this->bEnableMotionBlur_ && !this->boostBlur_ && this->ship_->hasLocalController() && this->ship_->hasHumanController())
-        {
-            this->boostBlur_ = new Shader(this->ship_->getScene()->getSceneManager());
-            this->boostBlur_->setCompositorName("Radial Blur");
-        }
-
-        if (this->boostBlur_ && this->maxSpeedFront_ != 0 && this->boostFactor_ != 1)
-        {
-            float blur = this->blurStrength_ * clamp((-velocity.z - this->maxSpeedFront_) / ((this->boostFactor_ - 1) * this->maxSpeedFront_), 0.0f, 1.0f);
-
-            this->boostBlur_->setVisible(blur > 0);
-            this->boostBlur_->setParameter(0, 0, "sampleStrength", blur);
-        }
+		// NOTE: Bullet always uses global coordinates.
+        this->ship_->addAcceleration(this->ship_->getOrientation() * (acceleration*this->getSpeedMultiply()+Vector3(0,0,-this->getSpeedAdd())), this->ship_->getOrientation() * this->relativePosition_);
+
+
+		// Hack to reset a temporary variable "direction"
+		this->ship_->oneEngineTickDone();
+		if(!this->ship_->hasEngineTicksRemaining())
+		{
+			this->ship_->setSteeringDirection(Vector3::ZERO);
+			this->ship_->resetEngineTicks();
+		}
     }
 
@@ -226,7 +215,4 @@
     {
         SUPER(Engine, changedActivity);
-
-        if (this->boostBlur_)
-            this->boostBlur_->setVisible(this->isVisible());
     }
 
@@ -238,12 +224,6 @@
         {
             this->shipID_ = ship->getObjectID();
-            if (ship->getEngine() != this)
-                ship->setEngine(this);
-
-            if (this->boostBlur_)
-            {
-                this->boostBlur_->destroy();
-                this->boostBlur_ = 0;
-            }
+            if (!ship->hasEngine(this))
+                ship->addEngine(this);
         }
     }
@@ -267,11 +247,15 @@
     }
 
-    void Engine::changedEnableMotionBlur()
-    {
-        if (!this->bEnableMotionBlur_)
-        {
-            this->boostBlur_->destroy();
-            this->boostBlur_ = 0;
-        }
-    }
+	void Engine::loadEngineTemplate()
+	{
+		if(!this->engineTemplate_.empty())
+		{
+			COUT(4)<<"Loading an engine template: "<<this->engineTemplate_<<"\n";
+			Template *temp = Template::getTemplate(this->engineTemplate_);
+			if(temp)
+			{
+				this->addTemplate(temp);
+			}
+		}
+	}
 }
Index: code/branches/bigships/src/orxonox/items/Engine.h
===================================================================
--- code/branches/bigships/src/orxonox/items/Engine.h	(revision 8136)
+++ code/branches/bigships/src/orxonox/items/Engine.h	(revision 8426)
@@ -54,4 +54,9 @@
             inline SpaceShip* getShip() const
                 { return this->ship_; }
+
+			inline void setRelativePosition(const Vector3 &position)
+				{ this->relativePosition_ = position; }
+			inline Vector3& getRelativePosition()
+				{ return this->relativePosition_; }
 
             inline void setBoostFactor(float factor)
@@ -119,16 +124,26 @@
                 { this->speedMultiply_=speedMultiply; }
 
+			
+            inline void setEngineTemplate(const std::string& temp)
+                { this->engineTemplate_ = temp; this->loadEngineTemplate(); }
+            inline const std::string& getEngineTemplate() const
+                { return this->engineTemplate_; }
+
         protected:
             virtual std::vector<PickupCarrier*>* getCarrierChildren(void) const
                 { return new std::vector<PickupCarrier*>(); }
             virtual PickupCarrier* getCarrierParent(void) const;
+			
+            void loadEngineTemplate();
 
         private:
             void registerVariables();
             void networkcallback_shipID();
-            void changedEnableMotionBlur();
+
+			std::string engineTemplate_;
 
             SpaceShip* ship_;
             unsigned int shipID_;
+			Vector3 relativePosition_;
 
             float boostFactor_;
@@ -148,8 +163,4 @@
             float accelerationLeftRight_;
             float accelerationUpDown_;
-
-            Shader* boostBlur_;
-            float blurStrength_;
-            bool bEnableMotionBlur_;
     };
 }
Index: code/branches/bigships/src/orxonox/worldentities/ControllableEntity.cc
===================================================================
--- code/branches/bigships/src/orxonox/worldentities/ControllableEntity.cc	(revision 8136)
+++ code/branches/bigships/src/orxonox/worldentities/ControllableEntity.cc	(revision 8426)
@@ -84,5 +84,4 @@
         this->client_angular_velocity_ = Vector3::ZERO;
 
-
         this->setConfigValues();
         this->setPriority( Priority::VeryHigh );
Index: code/branches/bigships/src/orxonox/worldentities/ControllableEntity.h
===================================================================
--- code/branches/bigships/src/orxonox/worldentities/ControllableEntity.h	(revision 8136)
+++ code/branches/bigships/src/orxonox/worldentities/ControllableEntity.h	(revision 8426)
@@ -93,5 +93,11 @@
             virtual void reload() {}
 
-            virtual void boost() {}
+            /**
+            @brief Tells the ControllableEntity to either start or stop boosting.
+                   This doesn't mean, that the ControllableEntity will do so, there might be additional restrictions on boosting, but if it can, then it will.
+            @param bBoost If true the ControllableEntity is told to start boosting, if false it is told to stop.
+            */
+            virtual void boost(bool bBoost) {}
+            
             virtual void greet() {}
             virtual void switchCamera();
Index: code/branches/bigships/src/orxonox/worldentities/MobileEntity.cc
===================================================================
--- code/branches/bigships/src/orxonox/worldentities/MobileEntity.cc	(revision 8136)
+++ code/branches/bigships/src/orxonox/worldentities/MobileEntity.cc	(revision 8426)
@@ -143,8 +143,19 @@
     {
         if (this->isDynamic())
+		{
             this->physicalBody_->applyCentralForce(btVector3(acceleration.x * this->getMass(), acceleration.y * this->getMass(), acceleration.z * this->getMass()));
-
+		}
+
+		// If not bullet-managed (deprecated? SpaceShip doesn't use this anymore for movement)
         this->linearAcceleration_ = acceleration;
     }
+
+	void MobileEntity::addAcceleration(const Vector3 &acceleration, const Vector3 &relativePosition)
+	{
+		if(this->isDynamic())
+		{
+			this->physicalBody_->applyForce(this->getMass() * btVector3(acceleration.x, acceleration.y, acceleration.z), btVector3(relativePosition.x, relativePosition.y, relativePosition.z));
+		}
+	}
 
     void MobileEntity::setAngularAcceleration(const Vector3& acceleration)
Index: code/branches/bigships/src/orxonox/worldentities/MobileEntity.h
===================================================================
--- code/branches/bigships/src/orxonox/worldentities/MobileEntity.h	(revision 8136)
+++ code/branches/bigships/src/orxonox/worldentities/MobileEntity.h	(revision 8426)
@@ -70,4 +70,10 @@
                 { return this->linearAcceleration_; }
 
+			// Added for making N engines work with spaceships
+			void addAcceleration(const Vector3& acceleration, const Vector3 &relativePosition);
+			inline void addAcceleration(float x, float y, float z)
+				{ this->addAcceleration(Vector3(x, y, z), Vector3(0,0,0)); }
+			// Getter function above
+
             void setAngularAcceleration(const Vector3& acceleration);
             inline void setAngularAcceleration(float x, float y, float z)
Index: code/branches/bigships/src/orxonox/worldentities/pawns/SpaceShip.cc
===================================================================
--- code/branches/bigships/src/orxonox/worldentities/pawns/SpaceShip.cc	(revision 8136)
+++ code/branches/bigships/src/orxonox/worldentities/pawns/SpaceShip.cc	(revision 8426)
@@ -37,4 +37,8 @@
 #include "items/Engine.h"
 
+// New as of Booster integration
+#include "Scene.h"
+#include "tools/Shader.h"
+
 namespace orxonox
 {
@@ -53,7 +57,8 @@
         this->localAngularAcceleration_.setValue(0, 0, 0);
         this->bBoost_ = false;
-        this->bPermanentBoost_ = false;
         this->steering_ = Vector3::ZERO;
-        this->engine_ = 0;
+        //this->engine_ = 0;
+		
+        this->boostBlur_ = 0;
 
         this->boostPower_ = 10.0f;
@@ -74,4 +79,5 @@
         this->enableCollisionCallback();
 
+		this->engineTicksNotDone = 0;
         this->setConfigValues();
         this->registerVariables();
@@ -80,6 +86,9 @@
     SpaceShip::~SpaceShip()
     {
-        if (this->isInitialized() && this->engine_)
-            this->engine_->destroy();
+        if (this->isInitialized())
+            this->removeAllEngines();
+		
+        if (this->boostBlur_)
+            this->boostBlur_->destroy();
     }
 
@@ -88,5 +97,5 @@
         SUPER(SpaceShip, XMLPort, xmlelement, mode);
 
-        XMLPortParam(SpaceShip, "engine",            setEngineTemplate,    getEngineTemplate,    xmlelement, mode);
+        //XMLPortParam(SpaceShip, "engine",            setEngineTemplate,    getEngineTemplate,    xmlelement, mode);
         XMLPortParamVariable(SpaceShip, "primaryThrust",  primaryThrust_,  xmlelement, mode);
         XMLPortParamVariable(SpaceShip, "auxilaryThrust", auxilaryThrust_, xmlelement, mode);
@@ -96,4 +105,6 @@
         XMLPortParamVariable(SpaceShip, "boostRate", boostRate_, xmlelement, mode);
         XMLPortParamVariable(SpaceShip, "boostCooldownDuration", boostCooldownDuration_, xmlelement, mode);
+
+		XMLPortObject(SpaceShip, Engine, "engines", addEngine, getEngine, xmlelement, mode);
     }
 
@@ -103,4 +114,8 @@
         registerVariable(this->auxilaryThrust_, VariableDirection::ToClient);
         registerVariable(this->rotationThrust_, VariableDirection::ToClient);
+        registerVariable(this->boostPower_, VariableDirection::ToClient);
+        registerVariable(this->boostPowerRate_, VariableDirection::ToClient);
+        registerVariable(this->boostRate_, VariableDirection::ToClient);
+        registerVariable(this->boostCooldownDuration_, VariableDirection::ToClient);
     }
 
@@ -108,4 +123,10 @@
     {
         SetConfigValue(bInvertYAxis_, false).description("Set this to true for joystick-like mouse behaviour (mouse up = ship down).");
+		
+        SetConfigValueExternal(bEnableMotionBlur_, "GraphicsSettings", "enableMotionBlur", true)
+            .description("Enable or disable the motion blur effect when moving very fast")
+            .callback(this, &SpaceShip::changedEnableMotionBlur);
+        SetConfigValueExternal(blurStrength_, "GraphicsSettings", "blurStrength", 3.0f)
+            .description("Defines the strength of the motion blur effect");
     }
 
@@ -128,14 +149,5 @@
         if (this->hasLocalController())
         {
-/*
-            this->localLinearAcceleration_.setX(this->localLinearAcceleration_.x() * getMass() * this->auxilaryThrust_);
-            this->localLinearAcceleration_.setY(this->localLinearAcceleration_.y() * getMass() * this->auxilaryThrust_);
-            if (this->localLinearAcceleration_.z() > 0)
-                this->localLinearAcceleration_.setZ(this->localLinearAcceleration_.z() * getMass() * this->auxilaryThrust_);
-            else
-                this->localLinearAcceleration_.setZ(this->localLinearAcceleration_.z() * getMass() * this->primaryThrust_);
-            this->physicalBody_->applyCentralForce(physicalBody_->getWorldTransform().getBasis() * this->localLinearAcceleration_);
-            this->localLinearAcceleration_.setValue(0, 0, 0);
-*/
+			// Handle mouse look
             if (!this->isInMouseLook())
             {
@@ -143,11 +155,12 @@
                 this->physicalBody_->applyTorque(physicalBody_->getWorldTransform().getBasis() * this->localAngularAcceleration_);
             }
-
             this->localAngularAcceleration_.setValue(0, 0, 0);
 
+			// Charge boostPower
             if(!this->bBoostCooldown_ && this->boostPower_ < this->initialBoostPower_)
             {
                 this->boostPower_ += this->boostPowerRate_*dt;
             }
+			// Use boostPower
             if(this->bBoost_)
             {
@@ -160,4 +173,25 @@
                 }
             }
+
+			// Enable Blur depending on settings
+			if (this->bEnableMotionBlur_ && !this->boostBlur_ && this->hasLocalController() && this->hasHumanController())
+			{
+				this->boostBlur_ = new Shader(this->getScene()->getSceneManager());
+				this->boostBlur_->setCompositorName("Radial Blur");
+			}
+
+			if (this->boostBlur_) // && this->maxSpeedFront_ != 0 && this->boostFactor_ != 1)
+			{
+				// TODO: this->maxSpeedFront_ gets fastest engine
+				float blur = this->blurStrength_ * clamp((-this->getLocalVelocity().z - 0.0f /*this->maxSpeedFront_*/) / ((150.0f /*boostFactor_*/ - 1) * 1.5f /*this->maxSpeedFront_*/), 0.0f, 1.0f);
+
+				// Show and hide blur effect depending on state of booster
+				if(this->bBoost_)
+					this->boostBlur_->setVisible(blur > 0);
+				else
+					this->boostBlur_->setVisible(false);
+
+				this->boostBlur_->setParameter(0, 0, "sampleStrength", blur);
+			}
         }
     }
@@ -207,69 +241,99 @@
     }
 
-    // TODO: something seems to call this function every tick, could probably handled a little more efficiently!
-    void SpaceShip::setBoost(bool bBoost)
-    {
-        if(bBoost == this->bBoost_)
-            return;
-
-        if(bBoost)
-            this->boost();
-        else
+    void SpaceShip::fire()
+    {
+    }
+
+    /**
+    @brief
+        Starts or stops boosting.
+    @param bBoost
+        Whether to start or stop boosting.
+    */
+    void SpaceShip::boost(bool bBoost)
+    {
+        if(bBoost && !this->bBoostCooldown_)
+            this->bBoost_ = true;
+        if(!bBoost)
+            this->bBoost_ = false;
+    }
+
+	void SpaceShip::addEngine(orxonox::Engine* engine)
+	{
+		//COUT(0)<<"Adding an Engine: " << engine << endl;
+		this->engineList_.push_back(engine);
+		engine->addToSpaceShip(this);
+		this->resetEngineTicks();
+	}
+	bool SpaceShip::hasEngine(Engine* engine)
+	{
+		for(unsigned int i=0; i<this->engineList_.size(); i++)
+		{
+			if(this->engineList_[i]==engine)
+				return true;
+		}
+		return false;
+	}
+	Engine* SpaceShip::getEngine(unsigned int i)
+	{
+		if(this->engineList_.size()>=i)
+			return 0;
+		else
+			return this->engineList_[i];
+	}
+	void SpaceShip::removeAllEngines()
+	{
+		for(unsigned int i=0; i<this->engineList_.size(); i++)
+			this->engineList_[i]->~Engine();
+	}
+
+	void SpaceShip::setSpeedFactor(float factor)
+	{
+		for(unsigned int i=0; i<this->engineList_.size(); i++)
+			this->engineList_[i]->setSpeedFactor(factor);
+	}
+	float SpaceShip::getSpeedFactor() // Calculate mean SpeedFactor.
+	{
+		float ret = 0; unsigned int i = 0;
+		for(; i<this->engineList_.size(); i++)
+			ret += this->engineList_[i]->getSpeedFactor();
+		ret /= (float)i;
+		return ret;
+	}
+	float SpaceShip::getMaxSpeedFront()
+	{
+		float ret=0;
+		for(unsigned int i=0; i<this->engineList_.size(); i++)
+		{
+			if(this->engineList_[i]->getMaxSpeedFront() > ret)
+				ret = this->engineList_[i]->getMaxSpeedFront();
+		}
+		return ret;
+	}
+	float SpaceShip::getBoostFactor()
+	{
+		float ret = 0; unsigned int i=0;
+		for(; i<this->engineList_.size(); i++)
+			ret += this->engineList_[i]->getBoostFactor();
+		ret /= (float)i;
+		return ret;
+	}
+
+    std::vector<PickupCarrier*>* SpaceShip::getCarrierChildren(void) const
+    {
+        std::vector<PickupCarrier*>* list = new std::vector<PickupCarrier*>();
+		for(unsigned int i=0; i<this->engineList_.size(); i++)
+			list->push_back(this->engineList_[i]);
+        return list;
+    }
+	
+	void SpaceShip::changedEnableMotionBlur()
+    {
+        if (!this->bEnableMotionBlur_)
         {
-            this->bBoost_ = false;
+            this->boostBlur_->destroy();
+            this->boostBlur_ = 0;
         }
     }
 
-    void SpaceShip::fire()
-    {
-    }
-
-    void SpaceShip::boost()
-    {
-        if(!this->bBoostCooldown_)
-            this->bBoost_ = true;
-    }
-
-    void SpaceShip::loadEngineTemplate()
-    {
-        if (!this->enginetemplate_.empty())
-        {
-            Template* temp = Template::getTemplate(this->enginetemplate_);
-
-            if (temp)
-            {
-                Identifier* identifier = temp->getBaseclassIdentifier();
-
-                if (identifier)
-                {
-                    BaseObject* object = identifier->fabricate(this);
-                    this->engine_ = orxonox_cast<Engine*>(object);
-
-                    if (this->engine_)
-                    {
-                        this->engine_->addTemplate(temp);
-                        this->engine_->addToSpaceShip(this);
-                    }
-                    else
-                    {
-                        object->destroy();
-                    }
-                }
-            }
-        }
-    }
-
-    void SpaceShip::setEngine(Engine* engine)
-    {
-        this->engine_ = engine;
-        if (engine && engine->getShip() != this)
-            engine->addToSpaceShip(this);
-    }
-
-    std::vector<PickupCarrier*>* SpaceShip::getCarrierChildren(void) const
-    {
-        std::vector<PickupCarrier*>* list = new std::vector<PickupCarrier*>();
-        list->push_back(this->engine_);
-        return list;
-    }
 }
Index: code/branches/bigships/src/orxonox/worldentities/pawns/SpaceShip.h
===================================================================
--- code/branches/bigships/src/orxonox/worldentities/pawns/SpaceShip.h	(revision 8136)
+++ code/branches/bigships/src/orxonox/worldentities/pawns/SpaceShip.h	(revision 8426)
@@ -59,9 +59,17 @@
 
             virtual void fire();
-            virtual void boost();
+            virtual void boost(bool bBoost); // Starts or stops boosting.
 
-            void setEngine(Engine* engine);
-            inline Engine* getEngine() const
-                { return this->engine_; }
+			void addEngine(Engine* engine);
+			bool hasEngine(Engine* engine);
+			Engine* getEngine(unsigned int i); // This one's for XMLPort
+			inline const std::vector<Engine*>& getEngineList()
+				{ return this->engineList_; }
+			void removeAllEngines();
+
+			void setSpeedFactor(float factor);
+			float getSpeedFactor(); // Gets mean speed factor
+			float getMaxSpeedFront(); // gets largest speed forward
+			float getBoostFactor(); // gets mean boost factor
 
             inline void setSteeringDirection(const Vector3& direction)
@@ -69,18 +77,13 @@
             inline const Vector3& getSteeringDirection() const
                 { return this->steering_; }
+			inline void resetEngineTicks()
+				{ this->engineTicksNotDone = this->engineList_.size(); }
+			inline void oneEngineTickDone()
+				{ this->engineTicksNotDone--; }
+			inline const bool hasEngineTicksRemaining()
+				{ return (this->engineTicksNotDone>0); }
 
-            void setBoost(bool bBoost);
             inline bool getBoost() const
                 { return this->bBoost_; }
-
-            inline void setEngineTemplate(const std::string& temp)
-                { this->enginetemplate_ = temp; this->loadEngineTemplate(); }
-            inline const std::string& getEngineTemplate() const
-                { return this->enginetemplate_; }
-
-            inline void setPermanentBoost(bool bPermanent)
-                { this->bPermanentBoost_ = bPermanent; }
-            inline bool getPermanentBoost() const
-                { return this->bPermanentBoost_; }
 
         protected:
@@ -90,5 +93,4 @@
             bool bBoost_;
             bool bBoostCooldown_;
-            bool bPermanentBoost_;
             float boostPower_;
             float initialBoostPower_;
@@ -106,11 +108,15 @@
             void registerVariables();
             virtual bool isCollisionTypeLegal(WorldEntity::CollisionType type) const;
-
-            void loadEngineTemplate();
             
+			//All things booster
+			void changedEnableMotionBlur();
             void boostCooledDown(void);
 
-            std::string enginetemplate_;
-            Engine* engine_;
+			Shader* boostBlur_;
+            float blurStrength_;
+            bool bEnableMotionBlur_;
+
+			std::vector<Engine*> engineList_;
+			int engineTicksNotDone; // Used for knowing when to reset temporary variables.
             Timer timer_;
     };